// 
const { internalError, serverError, successCode } = require("../../controllers/statusCode");
const CURRENTDATE = require("../../controllers/todayDate");
const { AsyncHandeler } = require("../../utils/AsyncHandeller");
const { ApiError } = require("../../utils/ApiError");
const { ApiResponse } = require("../../utils/ApiResponce");
const conDB = require("../../db/database");




const INSERT_quotation = AsyncHandeler(async(req, res)=>{
    try {
        const {type_of_insert} = req.body;
        let sql, values;

        if (!type_of_insert) {
            return res.status(internalError).json(new ApiError(internalError, "Provide a valid 'type_of_insert' value."))
        }


        // 
        if (type_of_insert === "Post") {
            // do
            const {date, clint_name, mobile, address, note}=req.body;
            const open_date = date || CURRENTDATE;
            sql = `INSERT INTO quotation_list (open_date, clint_name, mobile, address, note) VALUES (?, ?, ?, ?, ?)`
            values = [open_date, clint_name, mobile, address, note]
        }

        else if(type_of_insert === "Update"){
            // do
            const {_id, date, clint_name, mobile, address, note}=req.body;
            const open_date = date || CURRENTDATE;
            sql = `UPDATE quotation_list SET open_date=?, clint_name=?, mobile=?, address=?, note=? WHERE _id=?`
            values = [open_date, clint_name, mobile, address, note, _id]
        }

        else if(type_of_insert === "SubPost"){
            // do
            const {tag_id, product_name, qty, unit_rate}= req.body;
            sql = `INSERT INTO quotation_product_list (tag_id, product_name, qty, unit_rate) VALUES (?, ?, ?, ?)`
            values = [tag_id, product_name, qty, unit_rate]
        }

        else if(type_of_insert === "SubUpdate"){
            // do
            const {_id, tag_id, product_name, qty, unit_rate}= req.body;
            sql = `UPDATE quotation_product_list SET tag_id=?, product_name=?, qty=?, unit_rate=? WHERE _id=?`
            values = [tag_id, product_name, qty, unit_rate, _id]
        }

        else{
            return res.status(internalError).json(new ApiError(internalError, "Invalid type_of_insert value.")); 
        }

        // call DataBase
        conDB.query(sql, values, (err, result)=>{
            if (err) {
                return res.status(internalError).json(new ApiError(internalError, "DataBase Error", err)); 
            }

            return res.status(successCode).json(new ApiResponse(successCode, result, `Data Set Propurly.`))
        });

    } catch (error) {
        return res.status(serverError).json(new ApiError(serverError, "Internal Server Error", error)); 
    }
})
module.exports = INSERT_quotation;