// 
const InsertAddName = require("./InsertAddName/InsertAddName.js");
const TableDataDelete = require("./TableDataDelete/TableDataDelete.js");
const TableName = require("./TableName/TableName.js");
const insert_ledger_list = require("./insert_ledger_list/insert_ledger_list.js");
const insert_product_name = require("./insert_product_name/insert_product_name.js");
const insert_mode_info = require("./insert_mode_info/insert_mode_info.js");

// 
const INSERT_quotation = require("./INSERT_quotation/INSERT_quotation.js");
const PurchaseApi = require("./PurchaseApi/PurchaseApi.js");
const SaleApi = require("./SaleApi/SaleApi.js");

// USER
const Get_user = require("./USER/Get_user.js");
const Create_user = require("./USER/Create_user.js");
// port = 3000


const api = async (app) => {
    // server root path
    app.get('/', async(req, res) => {
        res.send('Hello Server !')
    });

    // get user & create user
    app.post("/get_user", Get_user);
    app.post("/create_user", Create_user);


    // get all Table Data From Targeted Table
    app.get("/data_get", TableName);   // link :- http://localhost:8000/data_get?table=group_name


    // INSERT data in = (brand_name , group_name, ledger_name, unit_name)
    app.get("/add_new_name-info", InsertAddName);   // link :- http://localhost:8000/add_new_name-info?table=ledger_name


    // delete Table Data From Targeted Table
    app.get("/data_delete", TableDataDelete);   // link :- http://localhost:8000/data_delete?table=ledger_name&name=Bangladesh


    // INSERT or UPDATE DATA IN ledger_list TABLE
    app.post("/post-ledger_list", insert_ledger_list);   // link :- http://localhost:8000/post-ledger_list


    // INSERT or UPDATE DATA IN product_name TABLE
    app.post("/post-product_name", insert_product_name);   // link :- http://localhost:8000/post-product_name


    // INSERT Payment/Recived list data
    app.post("/post-payment_and_recived", insert_mode_info);    // link :- http://localhost:8000/post-payment_and_recived




                // this section api call for learge data insert or update in table with subTable



    // quotation_list with quotation_product_list add or update
    app.post("/post-quotation", INSERT_quotation);


    // purchase_list & purchae_return_list with purchase_product_list & purchae_return_product_list add or update
    app.post("/post-purchase", PurchaseApi);
    
    // sale_list & sale_return_list with sale_product_list & sale_return_product_list add or update
    app.post("/post-sale", SaleApi);


};
module.exports = api;