// 
const { internalError, serverError, successCode } = require("../../controllers/statusCode");
const CURRENTDATE = require("../../controllers/todayDate");
const { AsyncHandeler } = require("../../utils/AsyncHandeller");
const { ApiError } = require("../../utils/ApiError");
const { ApiResponse } = require("../../utils/ApiResponce");
const conDB = require("../../db/database");



const insert_ledger_list = AsyncHandeler(async(req, res)=>{
    try {
        // 
        const {ledger_group, ledger, designation, mobile, email, location, address, open_amount, date}= req.body;
        const open_date = date || CURRENTDATE;   // day-month-year
        
        // 
        const sql = `
        INSERT INTO ledger_list (
            ledger_name,
            ledger_this_name,
            designation,
            mobile,
            email,
            location,
            address,
            open_amount,
            open_date
        ) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)
        ON DUPLICATE KEY UPDATE
            ledger_name = VALUES(ledger_name),
            designation = VALUES(designation),
            mobile = VALUES(mobile),
            email = VALUES(email),
            location = VALUES(location),
            address = VALUES(address),
            open_amount = VALUES(open_amount)
        `;
        const data = [
            ledger_group, ledger, designation, mobile, email, location, address, open_amount, open_date
        ];
        if (!data) {
            return res
            .status(internalError)
            .json(new ApiError(internalError, "Api Error"))
        };

        // 
        conDB.query(sql, data, async(err, result)=>{
            if (err) {
               return res
               .status(internalError)
               .json(new ApiError(internalError, "Database error")) 
            };

            // 
            return res
            .status(successCode)
            .json(new ApiResponse(successCode, result, "Data Add or Update Successfully"))
        })

    } catch (error) {
        return res
        .status(serverError)
        .json(new ApiError(serverError, 'Internal Server Error', error.message))
    }
});
module.exports = insert_ledger_list;