// 
const { internalError, serverError, successCode } = require("../../controllers/statusCode");
const CURRENTDATE = require("../../controllers/todayDate");
const { AsyncHandeler } = require("../../utils/AsyncHandeller");
const { ApiError } = require("../../utils/ApiError");
const { ApiResponse } = require("../../utils/ApiResponce");
const conDB = require("../../db/database");



const insert_product_name = AsyncHandeler(async(req, res)=>{
    try {
        // 
        const {obj}= req.body;
        const {group_name, brand_name, product_name, warranty, warranty_day, purchase_rate, sale_rate, unit, date}= obj;
        const open_date = date || CURRENTDATE;   // day-month-year
        
        // 
        const sql = `
        INSERT INTO product_name (
            group_name,
            brand_name,
            product_name,
            warranty,
            warranty_day,
            purchase_rate,
            sale_rate,
            unit_name,
            open_date
        ) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)
        ON DUPLICATE KEY UPDATE
            group_name = VALUES(group_name),
            brand_name = VALUES(brand_name),
            warranty = VALUES(warranty),
            warranty_day = VALUES(warranty_day),
            purchase_rate = VALUES(purchase_rate),
            sale_rate = VALUES(sale_rate),
            unit_name = VALUES(unit_name)
        `;
        const data = [
            group_name, brand_name, product_name, warranty, warranty_day, purchase_rate, sale_rate, unit, open_date
        ];
        if (!data) {
            return res
            .status(internalError)
            .json(new ApiError(internalError, "Api Error"))
        };

        // 
        conDB.query(sql, data, async(err, result)=>{
            if (err) {
               return res
               .status(internalError)
               .json(new ApiError(internalError, "Database error", err)) 
            };

            // 
            return res
            .status(successCode)
            .json(new ApiResponse(successCode, result, "Data Add or Update Successfully"))
        })

    } catch (error) {
        return res
        .status(serverError)
        .json(new ApiError(serverError, 'Internal Server Error', error.message))
    }
});
module.exports = insert_product_name;